#include "modeselectframe.h"
#include <QVBoxLayout>
#include <QFile>
#include <QTextStream>
#include "../PluginService/ksystemsetting_unit.h"

//定义选项控件数量
#define MODE_BNT_NUM    2

namespace KInstaller{

using namespace KServer;
modeselect::modeselect(QWidget* parent):QWidget(parent)
{
    initUI();
    addStyleSheet();
    translateStr();
    emit bntList.at(0)->click();
}

void modeselect::initUI()
{
    QVBoxLayout *usersetupLayout = new  QVBoxLayout();
    this->setLayout(usersetupLayout);
    usersetupLayout->setContentsMargins(0, 0, 0, 0);
    usersetupLayout->setSpacing(0);

    m_mainTitle= new QLabel(this);
    m_mainTitle->setObjectName("modeselect_m_mainTitle");
    usersetupLayout->addItem(new QSpacerItem(10, 40, QSizePolicy::Expanding, QSizePolicy::Minimum));
    usersetupLayout->addWidget(m_mainTitle, 1, Qt::AlignCenter | Qt::AlignTop);
    usersetupLayout->addItem(new QSpacerItem(10, 28, QSizePolicy::Expanding, QSizePolicy::Minimum));

    for (int  k= 0; k < MODE_BNT_NUM; k++) {
        chiceBtn* bnt=new chiceBtn(this, k+1);
        usersetupLayout->addWidget(bnt, 1, Qt::AlignCenter);
        usersetupLayout->addItem(new QSpacerItem(10, 28, QSizePolicy::Expanding, QSizePolicy::Minimum));
        connect(bnt, &chiceBtn::clickedSignal, this, &modeselect::changemodel);
        connect(this, &modeselect::modeSelect, [=] (chiceBtn *nt) {if(nt!=bnt)bnt->setBntValue(false);});
        bnt->bnt_id=k;
        bntList.append(bnt);
    }

    usersetupLayout->addItem(new QSpacerItem(10, 2800, QSizePolicy::Expanding, QSizePolicy::Expanding));
}

void modeselect::addStyleSheet()
{
    QFile file(":/res/qss/modeselectframe.css");
    file.open(QFile::ReadOnly);
    QTextStream filetext(&file);
    QString stylesheet = filetext.readAll();
    file.close();
    this->setStyleSheet(stylesheet);
}

void modeselect::translateStr()
{
    m_mainTitle->setText(tr("Register account"));

    int k=0;
    if(k<bntList.count())
    {
        bntList.at(k)->setObjectName("Register_immediately");
        bntList.at(k)->mainTitle->setText(tr("Register immediately"));
//        bntList.at(k)->subTitle->setText("");
        k++;
    }

    if(k<bntList.count())
    {
        bntList.at(k)->setObjectName("Register_later");
        bntList.at(k)->mainTitle->setText(tr("Register later"));
       bntList.at(k)->subTitle->setText(tr("After the system installation is completed, an account will be created when entering the system."));
//oem2阶段不能选择稍后创建
      if(KServer::ReadSettingIni("config","first_mode").compare("oem2")==0)
      {
        bntList.at(k)->setDisabled(true);
        bntList.at(k)->setCheckable(false);
      }
       else{
        bntList.at(k)->setDisabled(false);
        bntList.at(k)->setCheckable(true);
      }
       k++;
    }

//    if(k<bntList.count())
//    {
//        bntList.at(k)->setObjectName("Use_old_later");
//        bntList.at(k)->mainTitle->setText(tr("Use old access"));
//        bntList.at(k)->subTitle->setText(tr("The previous account will be used for login and historical data will be retained. Make sure you remember the password of your previous account."));
//        k++;
//    }

    if(currentBnt!=nullptr)
    {
          emit changeNextButton();
          emit enableNextButton(true);
    }
}

void modeselect::changemodel(chiceBtn *bnt)
{
    currentBnt=bnt;
    emit changeNextButton();
    emit enableNextButton(true);
    emit modeSelect(bnt);

}

void modeselect::checkactive(QWidget *p)
{
    if(p==this)
    {
       enableNextButton(true);
    }
}

}
